#include <windows.h>
#include <stdio.h>




typedef struct {
	int HTotal;
	int HDisp;
	int HBStart;
	int HSStart;
	int HSEnd;
	int HBEnd;
	int VTotal;
	int VDisp;
	int VBStart;
	int VSStart;
	int VSEnd;
	int VBEnd;

	int width;
	int height;
	int hpolarity;
	int vpolarity;
	int doublescan;
	int interlace;

	long dotclockHz;
	long horzHz;
	long vert001Hz;

	int interlaceratio;
	int compositesync;
	int depth;
	int sis_denumerator;
	int sis_postscalar;
	int sis_divider;
	int sis_numerator;
	int sis_seqdivider;
} CRTCPARAM;


static CRTCPARAM mode640x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  800, 640, 648, 677, 728, 792,   262, 240, 242, 247, 249, 250,

// width height HPlr VPlr DblScn Intrlc
	 640,	480,   1,	1,	   0,	  1,

// dotclkHz  horzHz  vertHz(in 0.01)
   12599999,  15750,   6000,

// Iratio csync depth  DeN PS Div  Num Seq
	  100,	  0,	0,	25, 4,	2,	88,  2
};





#define w32_init_g400					1
#define w32_io_out_byte 				2
#define w32_io_out_word 				3
#define w32_io_out_dword				4
#define w32_io_in_byte					5
#define w32_io_in_word					6
#define w32_io_in_dword 				7
#define w32_g400_idxreg_in_byte 		8
#define w32_g400_idxreg_out_byte		9
#define w32_g400_crtcextreg_in_byte    10
#define w32_g400_crtcextreg_out_byte   11


#define HDISPSKEW	0		//	0 to 3
#define HSYNCDELAY	0		//	0 to 3



LRESULT CALLBACK WindowFunc( HWND, UINT, WPARAM, LPARAM);
char szWinName[] = "G400_Interlace";

HANDLE	hVxD;
DWORD	cbBytesReturned;


static BYTE _in(int edx);
static void _out(int edx, int al);
static void SetG400InterlaceMode(void);

void SetSeqReg(int __idx, int data);
int GetSeqReg(int __idx);
int GetAtrbData(int __idx);
void SetAtrbData(int __idx, int data);
void SetCrtcReg(int __idx, int data);
int GetCrtcReg(int __idx);
DWORD BitMov(DWORD dstdata, int dstbitpos, DWORD srcdata, int srcbitpos);

static DWORD GetBytePerLine(void);
static void SetBytePerLine(DWORD d0);
static void SetInterlace(int flag, int HSyncStart, int HSyncEnd, int HTotal, int ratio);
static int CheckHorizontalTotal(int HTotal, int hzoom);
long CalcDotclock(long Vert001Hz, int HTotal, int VTotal, int interlace);
static void AdjustSyncParam(CRTCPARAM *cp, long dotclock);
static void AdjustCrtcParam(CRTCPARAM *cp, int hzoom);
static long get_vclk_param(unsigned long vclk, int *N, int *M, int *P, int *S);
void DisableGenerateSignal(void);
void EnableGenerateSignal(void);
void SetGenericVGARegister(CRTCPARAM *cp);
void SetG400ExtRegister(CRTCPARAM *cp);
static void SetVClock(int N, int M, int P, int S);
static void SetHZoom(int d0);
static void SetDoubleScan(int flag);
void SetHVPolarity(int HPolar, int VPolar);

BOOL InitG400(void);






























































































DWORD CurrentBytePerLine = 0;

int WMPAINT_Counter = 0;



BOOL InitG400(void)
{
	return	DeviceIoControl(
				hVxD,
				w32_init_g400,
				NULL, 0,
				NULL, 0,
				&cbBytesReturned,
				NULL
			);
}






void _out(int edx, int al)
{
	DWORD d0[2];

	d0[0] = edx;
	d0[1] = (DWORD)al;
	DeviceIoControl(
			hVxD,
			w32_io_out_byte,
			&d0,   8,
			NULL,  0,
			&cbBytesReturned,
			NULL
	);
}

BYTE _in(int edx)
{
	DWORD eax;

	DeviceIoControl(
			hVxD,
			w32_io_in_byte,
			&edx,	4,
			&eax,	4,
			&cbBytesReturned,
			NULL
	);
	return((BYTE)eax);
}







BYTE G400IdxReg_inb(DWORD edx)
{
	DWORD eax;

	DeviceIoControl(
		hVxD,
		w32_g400_idxreg_in_byte,
		&edx,	4,
		&eax,	4,
		&cbBytesReturned,
		NULL
	);
	return (BYTE)eax;
}


void G400IdxReg_outb(DWORD edx, DWORD eax)
{
	DWORD d0[2];

	d0[0] = edx;
	d0[1] = eax;
	DeviceIoControl(
		hVxD,
		w32_g400_idxreg_out_byte,
		&d0,   8,
		NULL,  0,
		&cbBytesReturned,
		NULL
	);
}


BYTE G400CrtcExtReg_inb(DWORD edx)
{
	DWORD eax;

	DeviceIoControl(
		hVxD,
		w32_g400_crtcextreg_in_byte,
		&edx,	4,
		&eax,	4,
		&cbBytesReturned,
		NULL
	);
	return (BYTE)eax;
}

void G400CrtcExtReg_outb(DWORD edx, DWORD eax)
{
	DWORD d0[2];

	d0[0] = edx;
	d0[1] = eax;
	DeviceIoControl(
		hVxD,
		w32_g400_crtcextreg_out_byte,
		&d0,   8,
		NULL,  0,
		&cbBytesReturned,
		NULL
	);
}











// #pragma argsused
int WINAPI WinMain( HINSTANCE hThisInst, HINSTANCE hPrevInst,
					LPSTR lpszArgs, int nWinMode)
{
	HWND hwnd;
	MSG msg;
	WNDCLASSEX wcl;
	RECT	windowrect;

	hVxD = CreateFile("\\\\.\\g400il.vxd", 0, 0, NULL, 0,
						FILE_FLAG_DELETE_ON_CLOSE, NULL);
	if( hVxD == INVALID_HANDLE_VALUE ) {
		MessageBox(NULL, "g400il.vxd not found", "Title", MB_OK);
		return(FALSE);
	}

	if( InitG400() == FALSE ){
		MessageBox(NULL, "g400 not found", "Title", MB_OK);
		return(FALSE);
	}


	CurrentBytePerLine = GetBytePerLine();

	wcl.hInstance = hThisInst;
	wcl.lpszClassName = szWinName;
	wcl.lpfnWndProc = WindowFunc;
	wcl.style = 0;
	wcl.cbSize = sizeof(WNDCLASSEX);
	wcl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wcl.hIconSm = LoadIcon(NULL, IDI_WINLOGO);
	wcl.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcl.lpszMenuName = NULL;
	wcl.cbClsExtra = 0;
	wcl.cbWndExtra = 0;
	wcl.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);

	if(!RegisterClassEx(&wcl)) return 0;

	windowrect.top	  = 0;
	windowrect.bottom = 0;
	windowrect.left   = 0;
	windowrect.right  = 0;
	AdjustWindowRect(&windowrect,
		WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME,
		FALSE
	);

	hwnd = CreateWindowEx(
		WS_EX_TOPMOST,
		szWinName,
		"G400Interlace 640x480",
		WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME,
		0,
		0,
		windowrect.right  - windowrect.left,
		windowrect.bottom - windowrect.top,
		HWND_DESKTOP,
		NULL,
		hThisInst,
		NULL
	);

	ShowWindow(hwnd, nWinMode);
	UpdateWindow(hwnd);

	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	CloseHandle(hVxD);

	return msg.wParam;
}

LRESULT CALLBACK WindowFunc(HWND hwnd, UINT message,
							WPARAM wParam, LPARAM lParam)
{
	switch(message) {
		case WM_CREATE:
			SetG400InterlaceMode();
			break;

		case WM_PAINT:
		{
			char a0[1024];
			HDC hdc;
			PAINTSTRUCT paintstruct;
			SetG400InterlaceMode();
			WMPAINT_Counter += 1;
			hdc = BeginPaint(hwnd, &paintstruct);
			sprintf(a0, "WM_PAINT : %d", WMPAINT_Counter);
			TextOut(hdc, 0, 0, a0, strlen(a0));
			EndPaint(hwnd, &paintstruct);
			break;
		}
		case WM_DESTROY:
			PostQuitMessage(0);
			break;

		default:
			return DefWindowProc(hwnd, message, wParam, lParam);
	}
	return(0);
}






















static DWORD GetBytePerLine(void)
{
	DWORD d0;

	d0 = GetCrtcReg(0x13);
	d0 = BitMov(d0, 8, G400CrtcExtReg_inb(0x00), 4);
	d0 = BitMov(d0, 9, G400CrtcExtReg_inb(0x00), 5);
	return d0;
}

static void SetBytePerLine(DWORD d0)
{
	SetCrtcReg(0x13, (BYTE)d0 & 0xFF);
	G400CrtcExtReg_outb(0x00, BitMov(G400CrtcExtReg_inb(0x00), 4, d0, 8));
	G400CrtcExtReg_outb(0x00, BitMov(G400CrtcExtReg_inb(0x00), 5, d0, 9));
}



static void SetInterlace(int flag, int HSyncStart, int HSyncEnd, int HTotal, int ratio)
{
	int d1;

	if(flag != 0){
		d1 = (HSyncStart/8) + (HSyncEnd/8) - (HTotal/8);
#if 1
		d1 = (d1 * 100) / ratio;
#endif
		d1 = (d1 / 2) - 1;
		if(d1 < 0)	  d1 = 0;
		if(d1 > 0xFF) d1 = 0xFF;
		G400CrtcExtReg_outb(0x05, d1 & 0xFF);
		G400CrtcExtReg_outb(0x00, BitMov(G400CrtcExtReg_inb(0x00), 7, 1, 0));
//		  SetBytePerLine(GetBytePerLine() * 2);
		SetBytePerLine(CurrentBytePerLine * 2);

	}
}



static int CheckHorizontalTotal(int HTotal, int hzoom)
{
	int result = 1;
#if 0
	int d0;

	d0 = 8 * hzoom;
	if( ((HTotal >> 3) % d0)  ==  (d0 - 1) ){
		result = 0;
	}
#endif
	return result;
}


long CalcDotclock(long Vert001Hz, int HTotal, int VTotal, int interlace)
{
	double f0;

	f0 = (double)VTotal;
	if(interlace != 0){
		f0 += 0.5;
	}
	f0 = f0 * HTotal;
	f0 = f0 * Vert001Hz;
	f0 = f0 / 100.0;

	return (long)f0;
}



static void AdjustSyncParam(CRTCPARAM *cp, long dotclock)
{
	int d0;

	if(dotclock == 0){
		cp->dotclockHz = CalcDotclock(cp->vert001Hz, cp->HTotal,
											cp->VTotal, cp->interlace);
	}else{
		cp->dotclockHz = dotclock;
	}
	cp->horzHz	   = cp->dotclockHz / cp->HTotal;
	d0 = cp->VTotal * 2;
	if(cp->interlace != 0){
		d0 += 1;
	}
	cp->vert001Hz  = (cp->horzHz * 100 * 2) / d0;
}


static void AdjustCrtcParam(CRTCPARAM *cp, int hzoom)
{
	cp->HTotal	*= hzoom;
	cp->HDisp	*= hzoom;
	cp->HBStart *= hzoom;
	cp->HBEnd	*= hzoom;
	cp->HSStart *= hzoom;
	cp->HSEnd	*= hzoom;

	cp->HBStart = cp->HDisp - 8;
	cp->HBEnd	= cp->HTotal - 8;
	cp->VBStart = cp->VDisp  - 1;
	cp->VBEnd	= cp->VTotal - 1;


	if( (cp->HBEnd - cp->HBStart) > (0x7F << 3) ){
		cp->HBEnd = cp->HBStart + (0x7F << 3);
	}
	if( (cp->HSEnd - cp->HSStart) > (0x1F << 3) ){
		cp->HSEnd = cp->HSStart + (0x1F << 3);
	}

	if(cp->interlace != 0){
		if( (cp->VTotal % 2) != 0 ){
			cp->VTotal += 1;
		}
	}

	if( CheckHorizontalTotal(cp->HTotal, hzoom) == 0 ){
		cp->HTotal += 8;
	}

	AdjustSyncParam(cp, 0);
}


#define BASE_FREQ 27000.0

static long get_vclk_param(unsigned long vclk, int *N, int *M, int *P, int *S)
{
	int d0;
	int d1;
	double fd;
	double dt;
	double tempfd;
	double tempdt;
	double ref = BASE_FREQ;
	double Fvco;

	vclk = vclk / 1000;
	*P = 0;
	if(vclk > 240000) vclk = 240000;
	if( 	 vclk <   30000){
		*P = 8;
	}else if(vclk <   60000){
		*P = 4;
	}else if(vclk <  120000){
		*P = 2;
	}else if(vclk <= 240000){
		*P = 1;
	}

	*N = 0;
	*M = 0;
	tempfd = 0;
	tempdt = 0;
	fd = vclk * (*P);
	dt = 240000;

	d0 = 8;
	while(d0 <= 128){
		d1 = 2;
		while(d1 <= 32){
			tempfd = ref * d0 / d1;
			tempdt = fd - tempfd;
			if(tempdt < 0) tempdt *= -1;
			if(dt > tempdt){
				*N = d0;
				*M = d1;
				dt = tempdt;
			}
			d1 += 1;
		}
		d0 += 1;
	}

	Fvco = ref * (*N) / (*M);
	tempfd = Fvco / (*P);

	*S = 0;
	if( 	 Fvco < 110000){
		*S = 0;
	}else if(Fvco < 170000){
		*S = 1;
	}else if(Fvco < 240000){
		*S = 2;
	}else if(Fvco < 310000){
		*S = 3;
	}

#if 0
	logerror( "N: %d\n", *N);
	logerror( "M: %d\n", *M);
	logerror( "P: %d\n", *P);
	logerror( "S: %d\n", *S);

	logerror( "Fd	%f\n", fd / (*P));
	logerror( "Fout %f\n", tempfd);
	logerror( "Fvco %f\n", Fvco);
#endif


	return (long)(tempfd * 1000);
}


void DisableGenerateSignal(void)
{
	BYTE d0;

	d0 = GetCrtcReg(0x17);
	d0 = d0 & 0x7F;
	SetCrtcReg(0x17, d0);
}

void EnableGenerateSignal(void)
{
	BYTE d0;

	d0 = GetCrtcReg(0x17);
	d0 = d0 | 0x80;
	SetCrtcReg(0x17, d0);
}


void SetGenericVGARegister(CRTCPARAM *cp)
{
	int d0;
	int d1;

	// Unlock
	SetCrtcReg(0x11, BitMov(GetCrtcReg(0x11), 7, 0, 0));

	// HTotal
	d0 = cp->HTotal;
	d0 = (d0 / 8) - 5;
	SetCrtcReg(0x00, d0 & 0xFF);

	// HDisp
	d0 = cp->HDisp;
	d0 = (d0 / 8) - 1;
	SetCrtcReg(0x01, d0 & 0xFF);

	// HBlankStart
	d0 = cp->HBStart;
	d0 = d0 / 8;
	SetCrtcReg(0x02, d0 & 0xFF);

	// HBlankEnd
	d0 = cp->HBEnd;
	d0 = d0 / 8;
	d1 = GetCrtcReg(0x03);
	d1 = BitMov(d1, 0, d0, 0);
	d1 = BitMov(d1, 1, d0, 1);
	d1 = BitMov(d1, 2, d0, 2);
	d1 = BitMov(d1, 3, d0, 3);
	d1 = BitMov(d1, 4, d0, 4);
	d1 = BitMov(d1, 5, HDISPSKEW, 0);	// horizontal disp skew
	d1 = BitMov(d1, 6, HDISPSKEW, 1);	// horizontal disp skew
	d1 = BitMov(d1, 7, 1, 0);			// compatible read
	SetCrtcReg(0x03, d1);
	SetCrtcReg(0x05, BitMov(GetCrtcReg(0x05), 7, d0, 5));

	// HSyncStart
	d0 = cp->HSStart;
	d0 = d0 / 8;
	SetCrtcReg(0x04, d0 & 0xFF);

	// HSyncEnd
	d0 = cp->HSEnd;
	d0 = d0 / 8;
	d1 = GetCrtcReg(0x05);
	d1 = BitMov(d1, 0, d0, 0);
	d1 = BitMov(d1, 1, d0, 1);
	d1 = BitMov(d1, 2, d0, 2);
	d1 = BitMov(d1, 3, d0, 3);
	d1 = BitMov(d1, 4, d0, 4);
	d1 = BitMov(d1, 5, HSYNCDELAY, 0);
	d1 = BitMov(d1, 6, HSYNCDELAY, 1);
	SetCrtcReg(0x05, d1);

	// VTotal
	d0 = cp->VTotal;
	d0 = d0 - 2;
	SetCrtcReg(0x06, d0 & 0xFF);
	SetCrtcReg(0x07, BitMov(GetCrtcReg(0x07), 0, d0, 8));
	SetCrtcReg(0x07, BitMov(GetCrtcReg(0x07), 5, d0, 9));

	// VDisp
	d0 = cp->VDisp;
	d0 = d0 - 1;
	SetCrtcReg(0x12, d0 & 0xFF);
	SetCrtcReg(0x07, BitMov(GetCrtcReg(0x07), 1, d0, 8));
	SetCrtcReg(0x07, BitMov(GetCrtcReg(0x07), 6, d0, 9));


	// VBlankStart
	d0 = cp->VBStart;
	SetCrtcReg(0x15, d0 & 0xFF);
	SetCrtcReg(0x07, BitMov(GetCrtcReg(0x07), 3, d0, 8));
	SetCrtcReg(0x09, BitMov(GetCrtcReg(0x09), 5, d0, 9));

	// VBlankEnd
	d0 = cp->VBEnd;
	SetCrtcReg(0x16, d0 & 0xFF);

	// VSyncStart
	d0 = cp->VSStart;
	SetCrtcReg(0x10, d0 & 0xFF);
	d1 = GetCrtcReg(0x07);
	d1 = BitMov(d1, 2, d0,	8);  // bit 8
	d1 = BitMov(d1, 7, d0,	9);  // bit 9
	SetCrtcReg(0x07, d1);

	// VSyncEnd
	d0 = cp->VSEnd;
	d0 = d0 & 0x0F;
	d1 = GetCrtcReg(0x11) & 0xF0;
	d1 = d1 | d0;
	SetCrtcReg(0x11, d1);

	// Double Scan Dis.
	SetCrtcReg(0x09, BitMov(GetCrtcReg(0x09), 7, 0, 0));

}


void SetG400ExtRegister(CRTCPARAM *cp)
{
	int d0;

	d0 = 0;
	d0 = BitMov(d0, 0, (cp->HTotal	>> 3) - 5, 8);
	d0 = BitMov(d0, 1, (cp->HBStart >> 3)	 , 8);
	d0 = BitMov(d0, 2, (cp->HSStart >> 3)	 , 8);
	d0 = BitMov(d0, 6, (cp->HBEnd	>> 3)	 , 6);
	G400CrtcExtReg_outb(0x01, d0);

	d0 = 0;
	d0 = BitMov(d0, 0, cp->VTotal - 2, 10);
	d0 = BitMov(d0, 1, cp->VTotal - 2, 11);
	d0 = BitMov(d0, 2, cp->VDisp  - 1, 10);
	d0 = BitMov(d0, 3, cp->VBStart	 , 10);
	d0 = BitMov(d0, 4, cp->VBStart	 , 11);
	d0 = BitMov(d0, 5, cp->VSStart	 , 10);
	d0 = BitMov(d0, 6, cp->VSStart	 , 11);
	G400CrtcExtReg_outb(0x02, d0);

	SetInterlace(cp->interlace, cp->HSStart, cp->HSEnd, cp->HTotal, cp->interlaceratio);

//	  g_interlaceflag = cp->interlace;
//	  g_endofline = cp->VTotal;
//	  g_valid = 1;
}


static void SetVClock(int N, int M, int P, int S)
{
	int PLLn;

	G400IdxReg_outb(0x1A, BitMov(G400IdxReg_inb(0x1A), 2, 1, 0));

	PLLn = _in(0x3CC);
	PLLn = PLLn | 0x0C;
	_out(0x3C2, PLLn);

	M -= 1;
	N -= 1;
	P -= 1;

	M = M & 0x1F;
	G400IdxReg_outb(0x4C, M);
	N = N & 0x7F;
	G400IdxReg_outb(0x4D, N);
	P = P | (S << 3);
	P = P & 0x1F;
	G400IdxReg_outb(0x4E, P);

	while(1){
		if( (G400IdxReg_inb(0x4F) & 0x40) != 0 ) break;
	}

	G400IdxReg_outb(0x1A, BitMov(G400IdxReg_inb(0x1A), 2, 0, 0));

}




static void SetHZoom(int d0)
{
	if(d0 == 1){
		d0 = 0;
	}else if(d0 == 2){
		d0 = 1;
	}else if(d0 == 4){
		d0 = 3;
	}else{
		d0 = 0;
	}
	G400IdxReg_outb(0x38, d0);
}


static void SetDoubleScan(int flag)
{
	int d0;

	d0 = GetCrtcReg(0x09) & ~0x1F;
	if(flag != 0){
		d0 = d0 | 0x01;
	}
	SetCrtcReg(0x09, d0);
}



void SetHVPolarity(int HPolar, int VPolar)
{
	BYTE d0;

	if(HPolar != 0) HPolar = 1;
	if(VPolar != 0) VPolar = 1;

	d0 = _in(0x3CC);
	d0 = d0 & 0x3F;
	d0 = d0 | (VPolar << 7) | (HPolar << 6);
	_out(0x3C2, d0);
}





DWORD BitMov(DWORD dstdata, int dstbitpos, DWORD srcdata, int srcbitpos)
{
	DWORD d0;
	DWORD d1;

	d1 = srcdata >> srcbitpos;
	d1 = d1 & 1;
	d0 = dstdata & ~(1 << dstbitpos);
	d1 = d1 << dstbitpos;
	d0 = d0 | d1;
	return d0;
}



void SetSeqReg(int __idx, int data)
{
	_out(0x3c4, __idx);
	_out(0x3c5, data);
}

int GetSeqReg(int __idx)
{
	int d0;

	_out(0x3c4, __idx);
	d0 = _in(0x3c5);
	return d0;
}


int GetAtrbData(int __idx)
{
	_in(0x3da);
	_out(0x3c0, __idx | (1 << 5));
	return _in(0x3c1);
}

void SetAtrbData(int __idx, int data)
{
	_in(0x3da);
	_out(0x3c0, __idx | 0x20);
	_out(0x3c0, data);
}

void SetCrtcReg(int __idx, int data)
{
	_out(0x3d4, __idx);
	_out(0x3d5, data);
}

int GetCrtcReg(int __idx)
{
	BYTE d0;

	_out(0x3d4, __idx);
	d0 = _in(0x3d5);
	return d0;
}








static void SetG400InterlaceMode(void)
{
	CRTCPARAM cp;
	int hzoom;
	int N, M, P, S;
	long vclk;

	cp = mode640x480_60;
	cp.HTotal += 8;
	hzoom = 1;
	AdjustCrtcParam(&cp, hzoom);
	vclk = get_vclk_param(cp.dotclockHz, &N, &M, &P, &S);
	AdjustSyncParam(&cp, vclk);

	DisableGenerateSignal();
	SetGenericVGARegister(&cp);
	SetG400ExtRegister(&cp);
	SetVClock(N, M, P, S);
	SetHZoom(hzoom);
	SetDoubleScan(cp.doublescan);
	SetHVPolarity(cp.hpolarity, cp.vpolarity);
	EnableGenerateSignal();

}
