.586p

WIN40COMPAT 	equ 	1

.XLIST
include VMM.INC
include VWIN32.INC
.LIST

VER_maj = 0
VER_min = 1
VER = VER_maj*100h+VER_min	; Version No.

; clc + ret
clcret macro
	clc
	ret
	endm

; stc + ret
stcret macro
	stc
	ret
	endm

; DEVICEIOCONTROLŕԂG[ԍ
ERROR_INVALID_DATA	EQU 0Dh
ERROR_BAD_LENGTH	EQU 18h
ERROR_NOT_SUPPORTED EQU 32h
ERROR_DEV_NOT_EXIST EQU 55


Declare_Virtual_Device g400il, Ver_maj, Ver_min, CtrlProc, Undefined_Device_ID,,,

VxD_DATA_SEG

vmmName 	db	'VMM	 '						; VMM޲

w32_procTable label dword			; Win32 applɒ񋟂鏈̱ڽð
	dd		OFFSET32 w32_init_g400					; 1
	dd		OFFSET32 w32_io_out_byte				; 2
	dd		OFFSET32 w32_io_out_word				; 3
	dd		OFFSET32 w32_io_out_dword				; 4
	dd		OFFSET32 w32_io_in_byte 				; 5
	dd		OFFSET32 w32_io_in_word 				; 6
	dd		OFFSET32 w32_io_in_dword				; 7
	dd		OFFSET32 w32_g400_idxreg_in_byte		; 8
	dd		OFFSET32 w32_g400_idxreg_out_byte		; 9
	dd		OFFSET32 w32_g400_crtcextreg_in_byte	;10
	dd		OFFSET32 w32_g400_crtcextreg_out_byte	;11

w32_procMax equ ($-w32_procTable)/4 			; 񋟏ݒ


g400_physical_address:
	dd		0
g400_linear_address:
	dd		0


VxD_DATA_ENDS


VxD_CODE_SEG


BeginProc CtrlProc
	Control_Dispatch SYS_DYNAMIC_DEVICE_INIT,dynDevInit
	Control_Dispatch SYS_DYNAMIC_DEVICE_EXIT,dynDevExit
	Control_Dispatch W32_DEVICEIOCONTROL,IOctrl
	clcret
EndProc CtrlProc


BeginProc dynDevInit
	clcret
EndProc dynDevInit


BeginProc dynDevExit
	clcret
EndProc dynDevExit









BeginProc IOctrl
	cmp 	ecx, DIOC_OPEN
	je		IOctrl_ok_ret
	cmp 	ecx, DIOC_CLOSEHANDLE
	je		IOctrl_ok_ret
	dec 	ecx
	cmp 	ecx, w32_procMax
	jae 	IOctrl_ns_error_ret
	call	w32_procTable[ecx*4]
	jc		IOctrl_error_ret

IOctrl_ok_ret:
	xor 	eax, eax
	clcret
IOctrl_ns_error_ret:
	mov 	eax, ERROR_NOT_SUPPORTED
IOctrl_error_ret:
	stcret
EndProc IOctrl



BeginProc w32_init_g400
	call	map_g400_mmio
	cmp 	eax, -1
	je		@f
	clcret
@@:
	mov 	eax, ERROR_DEV_NOT_EXIST
	stcret
endProc w32_init_g400




BeginProc map_g400_mmio
;
;	out 	eax 	-1 or linear address
;
	push	ebx
	push	ecx
	push	edx
	push	esi
	push	edi
	cli

	mov 	esi, 0
	mov 	eax, 0B102h 	; Find Device
	mov 	ecx, 00525h 	; Device ID 	G400
	mov 	edx, 0102Bh 	; Vender ID 	Matrox
	push	1Ah
	VMMcall Exec_VXD_Int
	jc		map_g400_mmio_err

	mov 	eax, 0B10Ah 	; Read Config DWORD
	mov 	edi, 14h
	push	1Ah
	VMMcall Exec_VXD_Int
	jc		map_g400_mmio_err
	and 	ecx, 0FFFFC000h
	mov 	dword ptr[g400_physical_address], eax
	mov 	edx, 4000h
	push	0
	push	edx
	push	ecx
	VMMcall _MapPhysToLinear
	add 	esp, 0Ch
	cmp 	eax, -1
	je		map_g400_mmio_err
	mov 	dword ptr[g400_linear_address], eax
	jmp 	map_g400_mmio_ret

map_g400_mmio_err:
	mov 	eax, -1

map_g400_mmio_ret:
	sti
	pop 	edi
	pop 	esi
	pop 	edx
	pop 	ecx
	pop 	ebx
	ret
EndProc map_g400_mmio



BeginProc w32_g400_idxreg_in_byte
	cmp 	dword ptr[g400_linear_address], 0
	je		@f

	cmp 	dword ptr[esi].cbOutBuffer, 4
	jne 	@f
	cmp 	dword ptr[esi].cbInBuffer, 4
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	ecx, dword ptr[esi].lpvOutBuffer
	cmp 	ecx, 0
	je		@f

	mov 	eax, dword ptr[ebx]
	mov 	edx, dword ptr[g400_linear_address]
	mov 	byte ptr[edx + 3C00h], al
	xor 	eax, eax
	mov 	al, byte ptr[edx + 3C0Ah]
	mov 	dword ptr[ecx], eax

	mov 	ebx, dword ptr[esi].lpcbBytesReturned
	cmp 	ebx, 0
	je		@f
	mov 	dword ptr[ebx], 4
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_g400_idxreg_in_byte



BeginProc w32_g400_idxreg_out_byte
	cmp 	dword ptr[g400_linear_address], 0
	je		@f

	cmp 	dword ptr[esi].cbInBuffer, 8
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	edx, dword ptr[ebx]
	mov 	eax, dword ptr[ebx + 4]
	mov 	ecx, dword ptr[g400_linear_address]
	mov 	byte ptr[ecx + 3C00h], dl
	mov 	byte ptr[ecx + 3C0Ah], al
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_g400_idxreg_out_byte




BeginProc w32_g400_crtcextreg_in_byte
	cmp 	dword ptr[g400_linear_address], 0
	je		@f

	cmp 	dword ptr[esi].cbOutBuffer, 4
	jne 	@f
	cmp 	dword ptr[esi].cbInBuffer, 4
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	ecx, dword ptr[esi].lpvOutBuffer
	cmp 	ecx, 0
	je		@f

	mov 	eax, dword ptr[ebx]
	mov 	edx, dword ptr[g400_linear_address]
	mov 	byte ptr[edx + 1FDEh], al
	xor 	eax, eax
	mov 	al, byte ptr[edx + 1FDFh]
	mov 	dword ptr[ecx], eax

	mov 	ebx, dword ptr[esi].lpcbBytesReturned
	cmp 	ebx, 0
	je		@f
	mov 	dword ptr[ebx], 4
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_g400_crtcextreg_in_byte



BeginProc w32_g400_crtcextreg_out_byte
	cmp 	dword ptr[g400_linear_address], 0
	je		@f

	cmp 	dword ptr[esi].cbInBuffer, 8
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	edx, dword ptr[ebx]
	mov 	eax, dword ptr[ebx + 4]
	mov 	ecx, dword ptr[g400_linear_address]
	mov 	byte ptr[ecx + 1FDEh], dl
	mov 	byte ptr[ecx + 1FDFh], al
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_g400_crtcextreg_out_byte








BeginProc w32_io_out_byte
	cmp 	dword ptr[esi].cbInBuffer, 8
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	edx, dword ptr[ebx]
	mov 	eax, dword ptr[ebx + 4]
	out 	dx, al
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_io_out_byte

BeginProc w32_io_out_word
	cmp 	dword ptr[esi].cbInBuffer, 8
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	edx, dword ptr[ebx]
	mov 	eax, dword ptr[ebx + 4]
	out 	dx, ax
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_io_out_word

BeginProc w32_io_out_dword
	cmp 	dword ptr[esi].cbInBuffer, 8
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	edx, dword ptr[ebx]
	mov 	eax, dword ptr[ebx + 4]
	out 	dx, eax
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_io_out_dword



BeginProc w32_io_in_byte
	cmp 	dword ptr[esi].cbOutBuffer, 4
	jne 	@f
	cmp 	dword ptr[esi].cbInBuffer, 4
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	ecx, dword ptr[esi].lpvOutBuffer
	cmp 	ecx, 0
	je		@f

	xor 	eax, eax
	mov 	edx, dword ptr[ebx]
	in		al, dx
	mov 	dword ptr[ecx], eax

	mov 	ebx, dword ptr[esi].lpcbBytesReturned
	cmp 	ebx, 0
	je		@f
	mov 	dword ptr[ebx], 4
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_io_in_byte

BeginProc w32_io_in_word
	cmp 	dword ptr[esi].cbOutBuffer, 4
	jne 	@f
	cmp 	dword ptr[esi].cbInBuffer, 4
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	ecx, dword ptr[esi].lpvOutBuffer
	cmp 	ecx, 0
	je		@f

	xor 	eax, eax
	mov 	edx, dword ptr[ebx]
	in		ax, dx
	mov 	dword ptr[ecx], eax

	mov 	ebx, dword ptr[esi].lpcbBytesReturned
	cmp 	ebx, 0
	je		@f
	mov 	dword ptr[ebx], 4
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_io_in_word

BeginProc w32_io_in_dword
	cmp 	dword ptr[esi].cbOutBuffer, 4
	jne 	@f
	cmp 	dword ptr[esi].cbInBuffer, 4
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	ecx, dword ptr[esi].lpvOutBuffer
	cmp 	ecx, 0
	je		@f

	xor 	eax, eax
	mov 	edx, dword ptr[ebx]
	in		eax, dx
	mov 	dword ptr[ecx], eax

	mov 	ebx, dword ptr[esi].lpcbBytesReturned
	cmp 	ebx, 0
	je		@f
	mov 	dword ptr[ebx], 4
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_io_in_dword


VxD_CODE_ENDS


	end
